# coding:utf-8
import math


class DroneMathmetics:
    def __init__(self):
        # print "DroneMathmetics __init__"
        pass

    def distance_math(self, hm_lon, dr_lon, hm_lat, dr_lat, hm_alt, dr_alt):
        if self.gpsdata_check(hm_lon, dr_lon, hm_lat, dr_lat) is False:
            return(0.0)
        else:
            distance = self.distance_calculate(
                hm_lon, dr_lon, hm_lat, dr_lat, hm_alt, dr_alt)
            return(distance)

    def distance_calculate(self, hm_lon, dr_lon,
                           hm_lat, dr_lat, hm_alt, dr_alt):
        a = 6378137.000     # Equatorial radius [m]
        b = 6356752.314     # Polar radius [m]
        e = math.sqrt((a**2 - b**2) / a**2)       # major eccentricity
        # print "e=" + str(e)

        x1 = hm_lon
        y1 = hm_lat

        x2 = dr_lon
        y2 = dr_lat

        if math.fabs(x1-x2) > 180.000:
            dx = math.radians((360.000 - math.fabs(x1-x2)))
        else:
            dx = math.radians(x1 - x2)

        dy = math.radians(y1 - y2)
        dz = math.fabs(hm_alt - dr_alt)

        uy = math.radians((y1 + y2) / 2.0)
        # print "uy=" + str(uy)

        W = math.sqrt(1 - (e**2) * (math.sin(uy)**2))
        # print "W=" + str(W)

        M = (a * (1 - e**2)) / W**3     # Meridian radius of curvature
        # print "M=" + str(M)

        N = a / W                     # Prime vertical radius of curvature
        # print "N=" + str(N)

        d = math.sqrt((dy * M)**2 + (dx * N * math.cos(uy))**2)

        # print "d=" + str(d)
        distance = math.sqrt(d**2 + dz**2)

        return (distance)

    def gpsdata_check(self, hm_lon, dr_lon, hm_lat, dr_lat):
        if -180.000 <= hm_lon <= 180.000:
            pass
        else:
            print "home longitude input error"
            return False

        if -180.000 <= dr_lon <= 180.000:
            pass
        else:
            print "drone longitude input error"
            return False

        if -90.000 <= hm_lat <= 90.000:
            pass
        else:
            print "home latitude input error"
            return False

        if -90.000 <= dr_lat <= 90.000:
            pass
        else:
            print "drone latitude input error"
            return False

        return True


if __name__ == "__main__":
    print "f = DroneMathmetics()"
    f = DroneMathmetics()
    distance = f.distance_math(
        139.929727, 139.767374, 37.494846, 35.681043, 0, 0)
    print "distance:" + str(distance / 1000) + "[km]"
